Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class LabelView2D

    java.lang.Object
      |
      +--javax.swing.text.View
            |
            +--javax.swing.text.LabelView2D

public class LabelView2D
extends View

A LabelView is a styled chunk of text that represents a view mapped over an element in the text model. The view supports breaking for the purpose of formatting. The fragments produced by breaking share the view that has primary responsibility for the element (i.e. they are nested classes and carry only a small amount of state of their own) so they can share its resources.

This view is generally responsible for displaying character level attributes in some way. Since this view represents text that may have tabs embedded in it, it implements the `TabableView` interface. Tabs will only be expanded if this view is embedded in a container that does tab expansion. ParagraphView is an example of a container that does tab expansion.

Fields inherited from class javax.swing.text.View
`BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`

Constructor Summary
`LabelView2D(Element elem)` Constructs a new view wrapped on an element.

Method Summary
`View` | `breakView(int axis, int p0, float pos, float len)` Breaks this view on the given axis at the given length.
`void` | `changedUpdate(DocumentEvent e, java.awt.Shape a, ViewFactory f)` Gives notification from the document that attributes were changed in a location that this view is responsible for.
`View` | `createFragment(int p0, int p1)` Creates a view that represents a portion of the element.
`float` | `getAlignment(int axis)` Determines the desired alignment for this view along an axis.
`int` | `getBreakWeight(int axis, float pos, float len)` Determines how attractive a break opportunity in this view is.
`protected java.awt.Font` | `getFont()` Fetch the Font used for this view.
`protected java.awt.FontMetrics` | `getFontMetrics()` Fetch the FontMetrics used for this view.
`int` | `getNextVisualPositionFrom(int pos, Position.Bias b, java.awt.Shape a, int direction, Position.Bias[] biasRet)` Provides a way to determine the next visually represented model location that one might place a caret.
`float` | `getPreferredSpan(int axis)` Determines the preferred span for this view along an axis.
`void` | `insertUpdate(DocumentEvent e, java.awt.Shape a, ViewFactory f)` Gives notification that something was added to the document in a location that this view is responsible for.
`java.awt.Shape` | `modelToView(int pos, java.awt.Shape a, Position.Bias b)` Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`void` | `paint(java.awt.Graphics g, java.awt.Shape a)` Renders a portion of a text style run.
`void` | `removeUpdate(DocumentEvent changes, java.awt.Shape a, ViewFactory f)` Gives notification that something was removed from the document in a location that this view is responsible for.
`protected void` | `setPropertiesFromAttributes()` Set the cached properties from the attributes.
`protected void` | `setStrikeThrough(boolean s)` Set whether or not the view has a strike/line through it.
`protected void` | `setSubscript(boolean s)` Set whether or not the view represents a subscript.
`protected void` | `setSuperscript(boolean s)` Set whether or not the view represents a superscript.
`protected void` | `setUnderline(boolean u)` Set whether or not the view is underlined.
`java.lang.String` | `toString()`
`int` | `viewToModel(float x, float y, java.awt.Shape a, Position.Bias[] biasReturn)` Provides a mapping from the view coordinate space to the logical coordinate space of the model.

Methods inherited from class javax.swing.text.View
`getAttributes, getChildAllocation, getContainer, getDocument, getElement, getEndOffset, getMaximumSpan, getMinimumSpan, getParent, getResizeWeight, getStartOffset, getView, getViewCount, getViewFactory, isVisible, modelToView, modelToView, preferenceChanged, setParent, setSize, viewToModel`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### LabelView2D

    public LabelView2D(Element elem)

  Constructs a new view wrapped on an element.
  Parameters:
    `elem` - the element

Method Detail

### setUnderline

    protected void setUnderline(boolean u)

  Set whether or not the view is underlined.

### setStrikeThrough

    protected void setStrikeThrough(boolean s)

  Set whether or not the view has a strike/line through it.

### setSuperscript

    protected void setSuperscript(boolean s)

  Set whether or not the view represents a superscript.

### setSubscript

    protected void setSubscript(boolean s)

  Set whether or not the view represents a subscript.

### setPropertiesFromAttributes

    protected void setPropertiesFromAttributes()

  Set the cached properties from the attributes.

### getFontMetrics

    protected java.awt.FontMetrics getFontMetrics()

  Fetch the FontMetrics used for this view.

### getFont

    protected java.awt.Font getFont()

  Fetch the Font used for this view.

### paint

    public void paint(java.awt.Graphics g,
                      java.awt.Shape a)

  Renders a portion of a text style run.
  Parameters:
    `g` - the rendering surface to use
    `a` - the allocated region to render into
  Overrides:
    paint in class View

### getPreferredSpan

    public float getPreferredSpan(int axis)

  Determines the preferred span for this view along an axis.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Overrides:
    getPreferredSpan in class View

### getAlignment

    public float getAlignment(int axis)

  Determines the desired alignment for this view along an axis. For the label, the alignment is along the font baseline for the y axis, and the superclasses alignment along the x axis.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Overrides:
    getAlignment in class View

### modelToView

    public java.awt.Shape modelToView(int pos,
                                      java.awt.Shape a,
                                      Position.Bias b)
                               throws BadLocationException

  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  Parameters:
    `pos` - the position to convert >= 0
    `a` - the allocated region to render into
  Returns:
    the bounding box of the given position
  Throws:
    BadLocationException - if the given position does not represent a valid location in the associated document
  Overrides:
    modelToView in class View
  See Also:
    `View.modelToView(int, java.awt.Shape, javax.swing.text.Position.Bias)`

### viewToModel

    public int viewToModel(float x,
                           float y,
                           java.awt.Shape a,
                           Position.Bias[] biasReturn)

  Provides a mapping from the view coordinate space to the logical coordinate space of the model.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `a` - the allocated region to render into
  Returns:
    the location within the model that best represents the given point of view >= 0
  Overrides:
    viewToModel in class View
  See Also:
    `View.viewToModel(float, float, java.awt.Shape, javax.swing.text.Position.Bias[])`

### getNextVisualPositionFrom

    public int getNextVisualPositionFrom(int pos,
                                         Position.Bias b,
                                         java.awt.Shape a,
                                         int direction,
                                         Position.Bias[] biasRet)
                                  throws BadLocationException

  Provides a way to determine the next visually represented model location that one might place a caret. Some views may not be visible, they might not be in the same order found in the model, or they just might not allow access to some of the locations in the model.
  Parameters:
    `pos` - the position to convert >= 0
    `a` - the allocated region to render into
    `direction` - the direction from the current position that can be thought of as the arrow keys typically found on a keyboard. This may be SwingConstants.WEST, SwingConstants.EAST, SwingConstants.NORTH, or SwingConstants.SOUTH.
  Returns:
    the location within the model that best represents the next location visual position.
  Throws:
    BadLocationException -
    java.lang.IllegalArgumentException - for an invalid direction
  Overrides:
    getNextVisualPositionFrom in class View

### getBreakWeight

    public int getBreakWeight(int axis,
                              float pos,
                              float len)

  Determines how attractive a break opportunity in this view is. This can be used for determining which view is the most attractive to call `breakView` on in the process of formatting. The higher the weight, the more attractive the break. A value equal to or lower than `View.BadBreakWeight` should not be considered for a break. A value greater than or equal to `View.ForcedBreakWeight` should be broken.

  This is implemented to forward to the superclass for the Y_AXIS. Along the X_AXIS the following values may be returned.

  View.ExcellentBreakWeight
    if there is whitespace proceeding the desired break location.
  View.BadBreakWeight
    if the desired break location results in a break location of the starting offset.
  View.GoodBreakWeight
    if the other conditions don't occur.
  This will normally result in the behavior of breaking on a whitespace location if one can be found, otherwise breaking between characters.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
    `pos` - the potential location of the start of the broken view >= 0. This may be useful for calculating tab positions.
    `len` - specifies the relative length from pos where a potential break is desired >= 0.
  Returns:
    the weight, which should be a value between View.ForcedBreakWeight and View.BadBreakWeight.
  Overrides:
    getBreakWeight in class View
  See Also:
    `LabelView`, `ParagraphView`, `BadBreakWeight`, `GoodBreakWeight`, `ExcellentBreakWeight`, `ForcedBreakWeight`

### breakView

    public View breakView(int axis,
                          int p0,
                          float pos,
                          float len)

  Breaks this view on the given axis at the given length. This is implemented to attempt to break on a whitespace location, and returns a fragment with the whitespace at the end. If a whitespace location can't be found, the nearest character is used.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
    `p0` - the location in the model where the fragment should start it's representation >= 0.
    `pos` - the position along the axis that the broken view would occupy >= 0. This may be useful for things like tab calculations.
    `len` - specifies the distance along the axis where a potential break is desired >= 0.
  Returns:
    the fragment of the view that represents the given span, if the view can be broken. If the view doesn't support breaking behavior, the view itself is returned.
  Overrides:
    breakView in class View
  See Also:
    `View.breakView(int, int, float, float)`

### createFragment

    public View createFragment(int p0,
                               int p1)

  Creates a view that represents a portion of the element. This is potentially useful during formatting operations for taking measurements of fragments of the view. If the view doesn't support fragmenting (the default), it should return itself.

  This view does support fragmenting. It is implemented to return a nested class that shares state in this view representing only a portion of the view.

  Parameters:
    `p0` - the starting offset >= 0. This should be a value greater or equal to the element starting offset and less than the element ending offset.
    `p1` - the ending offset > p0. This should be a value less than or equal to the elements end offset and greater than the elements starting offset.
  Overrides:
    createFragment in class View
  See Also:
    `LabelView`

### changedUpdate

    public void changedUpdate(DocumentEvent e,
                              java.awt.Shape a,
                              ViewFactory f)

  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  Parameters:
    `e` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  Overrides:
    changedUpdate in class View
  See Also:
    `View.changedUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

### insertUpdate

    public void insertUpdate(DocumentEvent e,
                             java.awt.Shape a,
                             ViewFactory f)

  Gives notification that something was added to the document in a location that this view is responsible for.
  Parameters:
    `changes` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  Overrides:
    insertUpdate in class View
  See Also:
    `View.insertUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

### removeUpdate

    public void removeUpdate(DocumentEvent changes,
                             java.awt.Shape a,
                             ViewFactory f)

  Gives notification that something was removed from the document in a location that this view is responsible for.
  Parameters:
    `changes` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  Overrides:
    removeUpdate in class View
  See Also:
    `View.removeUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

### toString

    public java.lang.String toString()

  Overrides:
    toString in class java.lang.Object

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.